; setup clears all and then creates one hundred turtles
to setup
  ca
  crt 100
end

; scatter1 sets the x and y coordinates of each
; turtle randomly 
to scatter1
  setup
  ask turtles [
    setxy random screen-size-x random screen-size-y
  ]
end

; scatter2 sends the turtles forward a random amount in random directions
to scatter2 
  no-display
  ask turtles [
    rt random 360
    fd random 100
  ]
  display
end


; This model was created as part of the project: CONNECTED MATHEMATICS:
; MAKING SENSE OF COMPLEX PHENOMENA THROUGH BUILDING OBJECT-BASED PARALLEL
; MODELS (OBPML)
; The project gratefully acknowledges the support of the National Science
; Foundation (Applications of Advanced Technologies Program) -- grant numbers
; RED #9552950 and REC #9632612.
; 
; Converted from StarLogoT to NetLogo, 2001.
; Copyright 1999  by Uri Wilensky. All rights reserved.
; 
; Permission to use, copy, or modify this software and its documentation for
; educational and research purposes only and without fee is hereby granted,
; provided that this copyright notice and the original authors' names appear
; on all copies and supporting documentation. For any other uses of this
; software, in original or modified form, including but not limited to
; distribution in whole or in part, specific prior permission must be
; obtained from Uri Wilensky. These programs shall not be used, rewritten, or
; adapted as the basis of a commercial software or hardware product without
; first obtaining appropriate licenses from Uri Wilensky. We make no
; representations about the suitability of this software for any purpose. It
; is provided "as is" without express or implied warranty.
@#$#@#$#@
GRAPHICS-WINDOW
310
10
620
341
12
12
12.0
1
10
0
0

CC-WINDOW
9
82
306
257
Command Center

BUTTON
71
10
126
43
NIL
scatter1
NIL
1
T
OBSERVER

BUTTON
130
10
185
43
scatter2
scatter2
NIL
1
T
OBSERVER

@#$#@#$#@
WHAT IS IT?
------------
This code example shows two ways to scatter turtles across the screen.  Notice the use of  screen-size-x and screen-size-y in the implementation of scatter1.  Scatter2 spreads out turtles in a different way, without the use of global constants that describe screen dimensions.  Both ways depend on the "random" reporter.
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

circle
true
0
Circle -7566196 true true 35 35 230

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

@#$#@#$#@
NetLogo 1.3beta1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
